#include <stdio.h>
#include <unistd.h>
#include <string.h>


#define BUFSIZE 1024


int main() 
{
  char *s= "hello world", buf[BUFSIZE];
  int fds[2];
  int size;

  pipe(fds);
  if (fork() == 0) /* Child */
  {
    close(fds[0]); 
    write(fds[1], s, strlen(s)+1);
  }
  else /* Parent */
  {
    close(fds[1]);
    size = read(fds[0], buf, BUFSIZE);
    printf("parent process, buf = %s, size = %d\n", buf, size);
  }
  
  return 0;
}
