/* implementing  "/bin/ps -ef | /bin/more" */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/wait.h>

int main()
{
  int fds[2];
  int child[2];
  char *argv[3];

  pipe(fds);

  if (fork()== 0) 
  {
    close(fds[1]);
    close(STDIN_FILENO); dup(fds[0]); /* redirect standard input to fds[0] */
    argv[0] = "/bin/more";
    argv[1] = NULL;           
    execv(argv[0], argv);
    exit(-1);
  }

  if (fork() == 0) 
  {
    close(fds[0]);
    close(STDOUT_FILENO); dup(fds[1]);  
    argv[0] = "/bin/ps";
    argv[1] = "-ef"; argv[2] = NULL;
    execv(argv[0], argv);
    exit(-2);
  }

  close(fds[0]); close(fds[1]);
  wait(child);
  wait(child+1); 

  return 0; 
} 
